Page MenuHomePhabricator

Prepare wikibugs gerrit bot for gerrit 2.14 / 2.15 / 3.0
Closed, ResolvedPublic

Description

Hi, this task is so that the bot will work with gerrit 2.14 and 2.15.

in gerrit 2.15, they are removing support for drafts and they replaced it with private changes. They also added support for wips. So not sure if we want the bot to ignore changes that are wips.

Event Timeline

Paladox created this task.Sep 14 2017, 3:44 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptSep 14 2017, 3:44 PM
valhallasw added a comment.EditedJul 1 2018, 8:14 AM

I'm not convinced it's a good idea to completely hide WIP patchsets from IRC.

On the one hand, it is nice to hide repetitive 'another WIP patchset uploaded' messages [1].
On the other hand, not reporting WIP changes also deprives that user of (useful) comments while the patch is still WIP. Earlier feedback is generally a good thing.

One additional note is that the current proposed implementation in wikibugs [2] essentially stops reporting if the task is WIP, even if updates had been sent before. In effect, the WIP flag thus becomes a 'mute-wikibugs' flag.

I like the idea of a mute-wikibugs flag, but I'm not certain if 'WIP' is the right way to do this. Maybe a hashtag 'muted' would be better?

Edit: actually, this seems exactly how WIP is intended in Gerrit: https://gerrit-review.googlesource.com/Documentation/intro-user.html#wip . That's not consistent with how it works in e.g. GitLab (where it prevents merges), but this is consistent with hiding events on IRC.

@Legoktm: what are your thoughts on this?

[1] Note that this is a more generic problem -- a flood of PS1 Jenkins-fail PS2 Jenkins-fail PS3 ... PS10 is also annoying in a channel. Part of this can be solved by the user doing a better job at their pre-push workflow. Part of this can possibly be solved by limiting wikibugs' output a bit. But that also decreases its usefulness...
[2] https://gerrit.wikimedia.org/r/c/labs/tools/wikibugs2/+/443220

Change 443220 had a related patch set uploaded (by Merlijn van Deen; owner: Paladox):
[labs/tools/wikibugs2@master] Ignore wips when creating a patchset

https://gerrit.wikimedia.org/r/443220

Change 491868 had a related patch set uploaded (by Paladox; owner: Paladox):
[labs/tools/wikibugs2@master] Add support for "WIPS"

https://gerrit.wikimedia.org/r/491868

Dzahn added a subscriber: Dzahn.

@Paladox What is the situation now since we will be on 3.x soon?

QChris added a subscriber: QChris.Jun 23 2020, 6:03 PM

On https://lists.wikimedia.org/pipermail/wikitech-l/2020-June/093528.html @Legoktm said that he "want[s] to make sure wikibugs can still parse the
stream-events feed properly." So I guess Legoktm is (also) looking into it?

I did a bit of testing against gerrit-test, and most everything looks like it works... I tested creating a new change, abandoning, rebasing. The only scenario I didn't test is that we properly ignore some of the bots.

One minor change is that the URLs are now the long form https://gerrit-test.wikimedia.org/r/c/labs/codesearch/+/605767 instead of https://gerrit-test.wikimedia.org/r/605767. Given that we are limited by message length on IRC, I think we want to use the short form.

Regarding WIP patches, currently changes to them go to IRC, but the transition from WIP <--> Ready for review doesn't. I don't know what the ideal behavior is because I don't really use the draft/WIP feature, but I do appreciate seeing draft patches to give a concept review, etc.

Change 607402 had a related patch set uploaded (by Legoktm; owner: Legoktm):
[labs/tools/wikibugs2@master] Use short Gerrit URLs after 3.0 upgrade

https://gerrit.wikimedia.org/r/607402

Dzahn added a comment.Jun 27 2020, 8:36 PM

Gerrit is now on 3.2. So this task should be closed or renamed?

Change 607402 merged by jenkins-bot:
[labs/tools/wikibugs2@master] Use short Gerrit URLs after 3.0 upgrade

https://gerrit.wikimedia.org/r/c/labs/tools/wikibugs2/ /607402

Legoktm closed this task as Resolved.Jun 28 2020, 6:26 AM
Legoktm claimed this task.

I think we're set now. If people want to see (or not see) WIP patches on IRC, let's discuss that in a few task.

Legoktm renamed this task from Prepare wikibugs gerrit bot for gerrit 2.14 / 2.15 to Prepare wikibugs gerrit bot for gerrit 2.14 / 2.15 / 3.0.Jun 28 2020, 6:26 AM
Dzahn awarded a token.Jun 28 2020, 6:47 AM

Change 491868 abandoned by Ahmon Dancy:
[labs/tools/wikibugs2@master] Add support for "WIPS"

Reason:
Abandoned in favor of 609488

https://gerrit.wikimedia.org/r/491868